/* Rohde & Schwarz - AMIQ Connection Utility ================================*/
/* Original Release: September 1999											 */
/* Rev 1.0, 09/1999, CVI 5.0.1					 							 */
/* Compatible with instr driver revision: "Rev 1.0, 9/1999, CVI 5.0.1"		 */
/* By: PP, ELCOM, a.s., CZ											 		 */
/*                                                                           */
/* Modification History: 													 */
/*																			 */
/*		None																 */
/*																			 */
/*===========================================================================*/

#include <ansi_c.h>
#include <userint.h>
#include "connection.h"
#include "rsamiq.h"

/*= Global Variable Definitions =============================================*/

static int cfgPanelHandle;
static int panelHandle;
static int resetState;
static int GPIBAddr;
static int serialPort;
static int conectType;
ViSession  session;

/* Invoke connection dialog */
int ConnectionDialog(int panel){
if ((panelHandle = LoadPanel (0, "Connection.uir", CPANEL)) < 0)
		return -1;
   cfgPanelHandle=panel;
   InstallPopup (panelHandle);
 return 0;
}

/* Quit connection dialog callback */
int CVICALLBACK QuitConn (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			  QuitUserInterface(0);/* Quit user interface */
			break;
	}
	return 0;
}

/* Connect callback */
int CVICALLBACK Connect (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
  char tempBuffer[100];

	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal (panelHandle, CPANEL_VIA, &conectType);
			GetCtrlVal (panelHandle, CPANEL_RESET, &resetState);
			GetCtrlVal (panelHandle, CPANEL_GPIBADDR, &GPIBAddr);
			GetCtrlVal (panelHandle, CPANEL_SERIALPORT, &serialPort);

			if(conectType)/* Connect via RS232 */
			{
				sprintf(tempBuffer,"ASRL%d",serialPort);
			}
			else/* Connect via GPIB */
			{
				sprintf(tempBuffer,"GPIB::%d",GPIBAddr);
			}
						
			/* Try to connect */
			if(rsamiq_init (tempBuffer, VI_ON, resetState,&session))
			{
				MessagePopup ("Connection Error", "Connection Failed");
				QuitUserInterface(0);
			}
			RemovePopup (0);
			DisplayPanel(cfgPanelHandle);
			break;
	}
	return 0;
}

/* End of connection.c */
